/**
 * ObjectType.java
 *
 * File generated from the XValidator4::ObjectType uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

// End of user code
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import org.w3c.dom.Node;

/**
 * Description of the class ObjectType.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "objectType", propOrder = { "extension", "kind", "name" })
@XmlRootElement(name = "objectType")
@Entity
@Table(name = "xval_object_type", schema = "public")
@SequenceGenerator(name = "xval_object_type_sequence", sequenceName = "xval_object_type_id_seq", allocationSize = 1)
public class ObjectType implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@XmlTransient
	@GeneratedValue(generator = "xval_object_type_sequence", strategy = GenerationType.SEQUENCE)
	@Column(name = "id", nullable = false, unique = true)
	private Integer id;

	@XmlAttribute(name = "extension", required = true)
	private String extension;

	@XmlAttribute(name = "kind", required = true)
	private Kind kind;

	@XmlAttribute(name = "name", required = true)
	@Column(name = "name", unique = true, nullable = false)
	private String name;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	/**
	 * Return extension.
	 * 
	 * @return extension
	 */
	public String getExtension() {
		return extension;
	}

	/**
	 * Set a value to attribute extension.
	 * 
	 * @param extension
	 *            .
	 */
	public void setExtension(String extension) {
		this.extension = extension;
	}

	/**
	 * Return kind.
	 * 
	 * @return kind
	 */
	public Kind getKind() {
		return kind;
	}

	/**
	 * Set a value to attribute kind.
	 * 
	 * @param kind
	 *            .
	 */
	public void setKind(Kind kind) {
		this.kind = kind;
	}

	/**
	 * Return name.
	 * 
	 * @return name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Set a value to attribute name.
	 * 
	 * @param name
	 *            .
	 */
	public void setName(String name) {
		this.name = name;
	}

	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "objectType", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result) + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		ObjectType other = (ObjectType) obj;
		if (name == null) {
			if (other.name != null) {
				return false;
			}
		} else if (!name.equals(other.name)) {
			return false;
		}
		return true;
	}

}